#!/usr/bin/perl

# $Id: lipm_fastaminlen.pl 1613 2018-07-16 15:43:32Z gouzy $

BEGIN
{
	use File::Basename;
	my $dirprg=dirname($0);
	unshift @INC, "$dirprg/../corelib";
	unshift @INC, "$dirprg/../lib";
	$ENV{PATH} .= ":$dirprg";
	$ENV{LANG} = "C";
	$VERSION = do { my @r = (q$Rev: 1613 $ =~ /\d+/g); sprintf "%d."."%02d" x $#r, @r }
}


use strict;
use warnings;
use General;
use GeneralBioinfo;
use ParamParser;
use Data::Dumper;
use Carp;

MAIN:
{
	my $o_param = New ParamParser('GETOPTLONG',\&Usage,'in=s','out=s','minlen=i');

	$o_param->AssertFileExists('in');
	$o_param->AssertDefined('out');
	$o_param->AssertInteger('minlen');
	my $minlen = $o_param->Get('minlen');

	my %h_seq=();
	&FastaToHash($o_param->Get('in'),\%h_seq);
	my $f_out = $o_param->GetStreamOut('out');
	foreach my $id (sort keys(%h_seq))
	{
		print $f_out ">$id\n$h_seq{$id}{sequence}\n" if ( $h_seq{$id}{len} >= $minlen );
	}
	$f_out->close;
}

sub Usage
{
print STDERR<<END
Keep ony sequences longer than minlen
$0 --in fastafile --out out.minlen.fasta --minlen integer
END
}

